# deepin sync daemon

`daemon` 主要提供 `module` 的同步功能，并提供 `DBus Interface` 用于 `token` 的设置和 `MachineID` 的获取。

`daemon` 程序在用户登录后自动启动，没有 `token` 时自动退出，有 `token` 时开始进行同步操作。


## DBus Interface

**Name:** `com.deepin.sync.Daemon`

**Path:** `/com/deepin/sync/Daemon`

**Interface:** `com.deepin.sync.Daemon`

### SetToken

方法原型：`SetToken(token string) error`

用户登录后调用此接口来设置 `token`，若 `token` 过期将启动登录界面重新获取。

### MachineID

`MachineID` 为属性，数据来源于 `/etc/machine-id`，用于表示一台主机.

主机的硬件信息也会随着 `MachineID` 一起上传，便于用户查看和管理。

-----------------------------------------------------------

## Modules

当前需要同步的模块如下：

``` shell
appearance
audio
dock
launcher
network
peripherals
screenedge
updater
```

每个模块的数据单独上传，`daemon` 记录每次有改变的 `module`，定时上传(5 ~ 10min)。

上传的数据格式如下:

``` json
{
    "module": "",
    "data": ""
}
```

每个 `module` 数据的获取和设置方法请看：[Modules 数据设置及获取](modules.md)


------------------------------------------------------------


## Sync

同步使用定时推送和定时拉取的方式，在推送或拉取数据之前都需要先获取 `signature` 和 `timestamp id`，方法如下：

1. 获取用户 `token`
2. 将需要调用的 `HTTP Method`, `upyun uri path` 和 `content md5` 连同 `token` 一起发送到服务端，来获取 `signature`，`date`，`path` 和 `timestamp id`

取得 `signature`，`date`，`path` 和 `timestamp id` 后，就可以执行相应的请求了。


### Push

若检测到 `module` 数据有改变，就把数据推送到 `upyun`，文件名后面加上 `timestamp id`


### Pull

在拉取到 `upyun` 的数据后，先于 `daemon` 中保存的上一次的 `timestamp id` 是否相同。

如果相同就不做任何处理。

如果大于本地的 `timestamp id`，就检查对应的 `module` 数据有没有改变，若没有改变就用拉取的数据替换本地数据，若没有改变就丢弃掉拉取的数据，然后将模块的数据上传

小于本地 `timestamp id` 可能在正常情况下是不可能出现的，处理时不考虑。


最后拉取或推送的过程都要保证互斥性，两种操作不能同时进行。

------------------------------------------------------------

## `upyun path`

每个 `module` 都有对应的 `path` 前缀，对应关系如下：

**数据 `PATH`：** `/<bucket>/<uid-hash>/<module>/data/`，数据文件的格式如：`data_<timestamp id>.json`

**文件 `PATH`：** `/<bucket>/<uid-hash>/<module>/files/`

文件 `PATH` 目前只有 `appearance` 有，用于上传用户壁纸，壁纸以文件的 `md5` 作为文件名，上传的 `data` 数据中要包含名称与 `md5` 的映射。
