package hardware

import (
	"io/ioutil"
)

const (
	batterySysfsDir = "/sys/class/power_supply"
)

func hasBattery(dir string) (bool, error) {
	finfos, err := ioutil.ReadDir(dir)
	if err != nil {
		return false, err
	}
	for _, finfo := range finfos {
		if ok, _ := isBatteryType(dir + "/" + finfo.Name() + "/type"); !ok {
			continue
		}
		return true, nil
	}
	return false, nil
}

func isBatteryType(filename string) (bool, error) {
	contents, err := ioutil.ReadFile(filename)
	if err != nil {
		return false, err
	}
	return string(contents) == "Battery\n", nil
}
