package hardware

import (
	"gir/glib-2.0"
)

const (
	fileOS = "/etc/deepin-version"

	kfSectionRelease = "Release"
	kfKeyVersion     = "Version"
	kfKeyType        = "Type"
)

func getOSFromDeepin(filename string) (string, error) {
	// TODO: fallback to /etc/lsb-release or /etc/os-release
	var kf = glib.NewKeyFile()
	_, err := kf.LoadFromFile(filename, glib.KeyFileFlagsNone)
	if err != nil {
		return "", err
	}
	defer kf.Free()

	ver, _ := kf.GetString(kfSectionRelease, kfKeyVersion)
	ty, _ := kf.GetString(kfSectionRelease, kfKeyType)
	var ret = "Deepin"
	if len(ty) != 0 && ty != "Desktop" {
		ret += " " + ty
	}
	ret += " " + ver
	return ret, nil
}
