package appearance

import (
	. "pkg.deepin.io/daemon/sync/modules/model"
	"reflect"
)

const (
	Name = "appearance"
)

type Data struct {
	FontSize      float64 `json:"font_size"`
	GTK           string  `json:"gtk"`
	Icon          string  `json:"icon"`
	Cursor        string  `json:"cursor"`
	FontStandard  string  `json:"font_standard"`
	FontMonospace string  `json:"font_monospace"`
	Version       string  `json:"version"`
}

func (core *Data) Name() string {
	return Name
}

func (core *Data) Model() interface{} {
	return &Data{}
}

func (core *Data) Equal(target DataIFC) bool {
	info := target.(*Data)
	return reflect.DeepEqual(core, info)
}

func (core *Data) Merge(current, cache DataIFC) {
	curInfo := current.(*Data)
	cacheInfo := cache.(*Data)
	if curInfo.GTK != cacheInfo.GTK {
		core.GTK = curInfo.GTK
	}
	if curInfo.Icon != cacheInfo.Icon {
		core.Icon = curInfo.Icon
	}
	if curInfo.Cursor != cacheInfo.Cursor {
		core.Cursor = curInfo.Cursor
	}
	if curInfo.FontStandard != cacheInfo.FontStandard {
		core.FontStandard = curInfo.FontStandard
	}
	if curInfo.FontMonospace != cacheInfo.FontMonospace {
		core.FontMonospace = curInfo.FontMonospace
	}
	if curInfo.FontSize != cacheInfo.FontSize {
		core.FontSize = curInfo.FontSize
	}
}

func (core *Data) GenCache(DataIFC) DataIFC {
	return core
}

func (core *Data) ToIFC(v interface{}) DataIFC {
	return v.(*Data)
}
