package audio

import (
	. "pkg.deepin.io/daemon/sync/modules/model"
	"reflect"
)

type soundEffect struct {
	Enabled bool `json:"enabled"`
}

type Data struct {
	Version     string       `json:"version"`
	SoundEffect *soundEffect `json:"soundeffect"`
}

const (
	Name = "audio"
)

func (core *Data) Name() string {
	return Name
}

func (core *Data) Model() interface{} {
	return &Data{}
}

func (core *Data) ToIFC(v interface{}) DataIFC {
	return v.(*Data)
}

func (core *Data) Equal(target DataIFC) bool {
	info := target.(*Data)
	return reflect.DeepEqual(core, info)
}

func (core *Data) GenCache(DataIFC) DataIFC {
	return core
}

func (core *Data) Merge(current, cache DataIFC) {
	curInfo := current.(*Data)
	cacheInfo := cache.(*Data)
	if !reflect.DeepEqual(curInfo.SoundEffect, cacheInfo.SoundEffect) {
		core.SoundEffect = curInfo.SoundEffect
	}
}
