package launcher

import (
	. "pkg.deepin.io/daemon/sync/modules/model"
	"reflect"
)

type Data struct {
	Version     string `json:"version"`
	DisplayMode string `json:"display_mode"`
	Fullscreen  bool   `json:"fullscreen"`
}

const (
	Name = "launcher"
)

func (core *Data) Name() string {
	return Name
}

func (core *Data) Model() interface{} {
	return &Data{}
}

func (core *Data) ToIFC(v interface{}) DataIFC {
	return v.(*Data)
}

func (core *Data) Equal(target DataIFC) bool {
	info := target.(*Data)
	return reflect.DeepEqual(core, info)
}

func (core *Data) GenCache(DataIFC) DataIFC {
	return core
}

func (core *Data) Merge(current, cache DataIFC) {
	curInfo := current.(*Data)
	cacheInfo := cache.(*Data)
	if curInfo.DisplayMode != cacheInfo.DisplayMode {
		core.DisplayMode = curInfo.DisplayMode
	}
	if curInfo.Fullscreen != cacheInfo.Fullscreen {
		core.Fullscreen = curInfo.Fullscreen
	}
}
