package peripherals

import (
	. "pkg.deepin.io/daemon/sync/modules/model"
	"reflect"
)

type Mouse struct {
	NaturalScroll bool `json:"natural_scroll"`
}
type Touchpad struct {
	NaturalScroll bool `json:"natural_scroll"`
}

type Data struct {
	Version  string    `json:"version"`
	Mouse    *Mouse    `json:"mouse"`
	Touchpad *Touchpad `json:"touchpad"`
}

const (
	Name = "peripherals"
)

func (core *Data) Name() string {
	return Name
}

func (core *Data) Model() interface{} {
	return &Data{}
}

func (core *Data) ToIFC(v interface{}) DataIFC {
	return v.(*Data)
}

func (core *Data) Equal(target DataIFC) bool {
	info := target.(*Data)
	return reflect.DeepEqual(core, info)
}

func (core *Data) GenCache(DataIFC) DataIFC {
	return core
}

func (core *Data) Merge(current, cache DataIFC) {
	curInfo := current.(*Data)
	cacheInfo := cache.(*Data)
	if !reflect.DeepEqual(curInfo.Mouse, cacheInfo.Mouse) {
		core.Mouse = curInfo.Mouse
	}
	if !reflect.DeepEqual(curInfo.Touchpad, cacheInfo.Touchpad) {
		core.Touchpad = curInfo.Touchpad
	}
}
