package screenedge

import (
	. "pkg.deepin.io/daemon/sync/modules/model"
	"reflect"
)

type Data struct {
	Version     string `json:"version"`
	LeftBottom  string `json:"left_bottom"`
	LeftTop     string `json:"left_top"`
	RightBottom string `json:"right_bottom"`
	RightTop    string `json:"right_top"`
}

const (
	Name = "screenedge"
)

func (core *Data) Name() string {
	return Name
}

func (core *Data) Model() interface{} {
	return &Data{}
}

func (core *Data) ToIFC(v interface{}) DataIFC {
	return v.(*Data)
}

func (core *Data) Equal(target DataIFC) bool {
	info := target.(*Data)
	return reflect.DeepEqual(core, info)
}

func (core *Data) GenCache(DataIFC) DataIFC {
	return core
}

func (core *Data) Merge(current, cache DataIFC) {
	curInfo := current.(*Data)
	cacheInfo := cache.(*Data)
	if curInfo.LeftBottom != cacheInfo.LeftBottom {
		core.LeftBottom = curInfo.LeftBottom
	}
	if curInfo.LeftTop != cacheInfo.LeftTop {
		core.LeftTop = curInfo.LeftTop
	}
	if curInfo.RightBottom != cacheInfo.RightBottom {
		core.RightBottom = curInfo.RightBottom
	}
	if curInfo.RightTop != cacheInfo.RightTop {
		core.RightTop = curInfo.RightTop
	}
}
