package updater

import (
	. "pkg.deepin.io/daemon/sync/modules/model"
	"reflect"
)

type Data struct {
	Version             string `json:"version"`
	AutoCheckUpdates    bool   `json:"auto_check_updates"`
	AutoDownloadUpdates bool   `json:"auto_download_updates"`
	AutoClean           bool   `json:"auto_clean"`
	MirrorSource        string `json:"mirror_source"`
	AppstoreRegion      string `json:"appstore_region"`
}

const (
	Name = "updater"
)

func (core *Data) Name() string {
	return Name
}

func (core *Data) Model() interface{} {
	return &Data{}
}

func (core *Data) ToIFC(v interface{}) DataIFC {
	return v.(*Data)
}

func (core *Data) Equal(target DataIFC) bool {
	info := target.(*Data)
	return reflect.DeepEqual(core, info)
}

func (core *Data) GenCache(DataIFC) DataIFC {
	return core
}

func (core *Data) Merge(current, cache DataIFC) {
	curInfo := current.(*Data)
	cacheInfo := cache.(*Data)
	if curInfo.AutoCheckUpdates != cacheInfo.AutoCheckUpdates {
		core.AutoCheckUpdates = curInfo.AutoCheckUpdates
	}
	if curInfo.AutoDownloadUpdates != cacheInfo.AutoDownloadUpdates {
		core.AutoDownloadUpdates = curInfo.AutoDownloadUpdates
	}
	if curInfo.AutoClean != cacheInfo.AutoClean {
		core.AutoClean = curInfo.AutoClean
	}
	if curInfo.MirrorSource != cacheInfo.MirrorSource {
		core.MirrorSource = curInfo.MirrorSource
	}
	if curInfo.AppstoreRegion != cacheInfo.AppstoreRegion {
		core.AppstoreRegion = curInfo.AppstoreRegion
	}
}
