package main

import (
	"fmt"
	"github.com/fsnotify/fsnotify"
	"pkg.deepin.io/daemon/sync/infrastructure/utils"
)

func main() {
	files := []string{
		"./testdata",
		"./testdata/data",
	}

	watcher, err := utils.NewFSWatcher(files)
	if err != nil {
		fmt.Println("Failed to watch files:", err, files)
		return
	}
	watcher.Watch(handleEvent, handleError)
}

func handleEvent(ev fsnotify.Event) {
	fmt.Println("Recieved event:", ev.String(), ev.Name)
	switch {
	case ev.Op&fsnotify.Chmod == fsnotify.Chmod:
		fmt.Println("\tChmod")
	case ev.Op&fsnotify.Create == fsnotify.Create:
		fmt.Println("\tCreate")
	case ev.Op&fsnotify.Remove == fsnotify.Remove:
		fmt.Println("\tRemove")
	case ev.Op&fsnotify.Rename == fsnotify.Rename:
		fmt.Println("\tRename")
	case ev.Op&fsnotify.Write == fsnotify.Write:
		fmt.Println("\tWrite")
	}
}

func handleError(err error) {
	fmt.Println("Occur error, exit:", err)
}
